'use strict';

var SDKStatusCode = /* @__PURE__ */ ((SDKStatusCode2) => {
  SDKStatusCode2[SDKStatusCode2["Error"] = -1] = "Error";
  SDKStatusCode2[SDKStatusCode2["Success"] = 1e4] = "Success";
  SDKStatusCode2[SDKStatusCode2["NoSupport"] = 10001] = "NoSupport";
  SDKStatusCode2[SDKStatusCode2["NoInit"] = 10002] = "NoInit";
  SDKStatusCode2[SDKStatusCode2["NoLogin"] = 10003] = "NoLogin";
  SDKStatusCode2[SDKStatusCode2["ChannelConfigError"] = 10004] = "ChannelConfigError";
  SDKStatusCode2[SDKStatusCode2["AggrateOrderError"] = 10005] = "AggrateOrderError";
  SDKStatusCode2[SDKStatusCode2["OrderNotifyError"] = 10006] = "OrderNotifyError";
  SDKStatusCode2[SDKStatusCode2["PresetOrderError"] = 10007] = "PresetOrderError";
  SDKStatusCode2[SDKStatusCode2["ScanCodeOrderError"] = 10008] = "ScanCodeOrderError";
  SDKStatusCode2[SDKStatusCode2["AccounteExceptionError"] = 10009] = "AccounteExceptionError";
  SDKStatusCode2[SDKStatusCode2["DeviceExceptionError"] = 10010] = "DeviceExceptionError";
  SDKStatusCode2[SDKStatusCode2["CreateExceptionError"] = 10011] = "CreateExceptionError";
  SDKStatusCode2[SDKStatusCode2["LoginError"] = 20001] = "LoginError";
  SDKStatusCode2[SDKStatusCode2["LoginFreezeError"] = 20002] = "LoginFreezeError";
  SDKStatusCode2[SDKStatusCode2["PayError"] = 30001] = "PayError";
  SDKStatusCode2[SDKStatusCode2["PayCloseError"] = 30002] = "PayCloseError";
  SDKStatusCode2[SDKStatusCode2["PayGameCurrencyError"] = 30003] = "PayGameCurrencyError";
  SDKStatusCode2[SDKStatusCode2["PayGoodsDirectError"] = 30004] = "PayGoodsDirectError";
  SDKStatusCode2[SDKStatusCode2["PayServiceCancelError"] = 30005] = "PayServiceCancelError";
  SDKStatusCode2[SDKStatusCode2["PayServiceError"] = 30006] = "PayServiceError";
  SDKStatusCode2[SDKStatusCode2["PayScanCodeError"] = 30007] = "PayScanCodeError";
  SDKStatusCode2[SDKStatusCode2["PayAccountFreezeError"] = 30008] = "PayAccountFreezeError";
  SDKStatusCode2[SDKStatusCode2["AdError"] = 40001] = "AdError";
  SDKStatusCode2[SDKStatusCode2["RewardedVideoAdError"] = 40002] = "RewardedVideoAdError";
  SDKStatusCode2[SDKStatusCode2["BannerAdError"] = 40003] = "BannerAdError";
  SDKStatusCode2[SDKStatusCode2["InterstitialAdError"] = 40004] = "InterstitialAdError";
  SDKStatusCode2[SDKStatusCode2["CustomAdError"] = 40005] = "CustomAdError";
  SDKStatusCode2[SDKStatusCode2["SurveyError"] = 50001] = "SurveyError";
  SDKStatusCode2[SDKStatusCode2["SurveyCancelError"] = 50002] = "SurveyCancelError";
  SDKStatusCode2[SDKStatusCode2["SubscribeMessageError"] = 60001] = "SubscribeMessageError";
  SDKStatusCode2[SDKStatusCode2["SubscribeMessageReportError"] = 60002] = "SubscribeMessageReportError";
  SDKStatusCode2[SDKStatusCode2["ShareAppMessageError"] = 70001] = "ShareAppMessageError";
  SDKStatusCode2[SDKStatusCode2["ShowShareMenuError"] = 70002] = "ShowShareMenuError";
  SDKStatusCode2[SDKStatusCode2["HideShareMenuError"] = 70003] = "HideShareMenuError";
  SDKStatusCode2[SDKStatusCode2["ShareMessageCardError"] = 70004] = "ShareMessageCardError";
  SDKStatusCode2[SDKStatusCode2["OnShareAppMessageError"] = 70005] = "OnShareAppMessageError";
  SDKStatusCode2[SDKStatusCode2["OffShareAppMessageError"] = 70006] = "OffShareAppMessageError";
  SDKStatusCode2[SDKStatusCode2["ServiceError"] = 80001] = "ServiceError";
  SDKStatusCode2[SDKStatusCode2["ServiceCancelError"] = 80002] = "ServiceCancelError";
  SDKStatusCode2[SDKStatusCode2["ServiceLinkError"] = 80003] = "ServiceLinkError";
  SDKStatusCode2[SDKStatusCode2["ShortcutError"] = 90001] = "ShortcutError";
  return SDKStatusCode2;
})(SDKStatusCode || {});
var SDKPayType = /* @__PURE__ */ ((SDKPayType2) => {
  SDKPayType2[SDKPayType2["Natve"] = 1] = "Natve";
  SDKPayType2[SDKPayType2["Service"] = 2] = "Service";
  SDKPayType2[SDKPayType2["QRCode"] = 3] = "QRCode";
  return SDKPayType2;
})(SDKPayType || {});

const md5 = (stringValue) => {
  function rotateLeft(lValue, iShiftBits) {
    return lValue << iShiftBits | lValue >>> 32 - iShiftBits;
  }
  function addUnsigned(lX, lY) {
    const lX8 = lX & 2147483648;
    const lY8 = lY & 2147483648;
    const lX4 = lX & 1073741824;
    const lY4 = lY & 1073741824;
    const lResult = (lX & 1073741823) + (lY & 1073741823);
    if (lX4 & lY4) {
      return lResult ^ 2147483648 ^ lX8 ^ lY8;
    }
    if (lX4 | lY4) {
      if (lResult & 1073741824) {
        return lResult ^ 3221225472 ^ lX8 ^ lY8;
      }
      return lResult ^ 1073741824 ^ lX8 ^ lY8;
    }
    return lResult ^ lX8 ^ lY8;
  }
  function F(x2, y, z) {
    return x2 & y | ~x2 & z;
  }
  function G(x2, y, z) {
    return x2 & z | y & ~z;
  }
  function H(x2, y, z) {
    return x2 ^ y ^ z;
  }
  function I(x2, y, z) {
    return y ^ (x2 | ~z);
  }
  function FF(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(F(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function GG(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(G(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function HH(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(H(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function II(a2, b2, c2, d2, x2, s, ac) {
    const v = addUnsigned(a2, addUnsigned(addUnsigned(I(b2, c2, d2), x2), ac));
    return addUnsigned(rotateLeft(v, s), b2);
  }
  function convertToWordArray(value) {
    let lWordCount;
    const lMessageLength = value.length;
    const lNumberOfWords_temp1 = lMessageLength + 8;
    const lNumberOfWords_temp2 = (lNumberOfWords_temp1 - lNumberOfWords_temp1 % 64) / 64;
    const lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
    const lWordArray = Array(lNumberOfWords - 1);
    let lBytePosition = 0;
    let lByteCount = 0;
    while (lByteCount < lMessageLength) {
      lWordCount = (lByteCount - lByteCount % 4) / 4;
      lBytePosition = lByteCount % 4 * 8;
      lWordArray[lWordCount] = lWordArray[lWordCount] | value.charCodeAt(lByteCount) << lBytePosition;
      lByteCount += 1;
    }
    lWordCount = (lByteCount - lByteCount % 4) / 4;
    lBytePosition = lByteCount % 4 * 8;
    lWordArray[lWordCount] = lWordArray[lWordCount] | 128 << lBytePosition;
    lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
    lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
    return lWordArray;
  }
  function wordToHex(lValue) {
    let WordToHexValue = "";
    let WordToHexValue_temp = "";
    let lByte;
    let lCount;
    for (lCount = 0; lCount <= 3; lCount++) {
      lByte = lValue >>> lCount * 8 & 255;
      WordToHexValue_temp = `0${lByte.toString(16)}`;
      WordToHexValue += WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
    }
    return WordToHexValue;
  }
  function utf8Encode(value) {
    const normalizeValue = value.replace(/\r\n/ug, "\n");
    let utftext = "";
    for (let n = 0; n < normalizeValue.length; n++) {
      const c2 = normalizeValue.charCodeAt(n);
      if (c2 < 128) {
        utftext += String.fromCharCode(c2);
      } else if (c2 > 127 && c2 < 2048) {
        utftext += String.fromCharCode(c2 >> 6 | 192);
        utftext += String.fromCharCode(c2 & 63 | 128);
      } else {
        utftext += String.fromCharCode(c2 >> 12 | 224);
        utftext += String.fromCharCode(c2 >> 6 & 63 | 128);
        utftext += String.fromCharCode(c2 & 63 | 128);
      }
    }
    return utftext;
  }
  let x = [];
  let k;
  let AA;
  let BB;
  let CC;
  let DD;
  let a;
  let b;
  let c;
  let d;
  const S11 = 7;
  const S12 = 12;
  const S13 = 17;
  const S14 = 22;
  const S21 = 5;
  const S22 = 9;
  const S23 = 14;
  const S24 = 20;
  const S31 = 4;
  const S32 = 11;
  const S33 = 16;
  const S34 = 23;
  const S41 = 6;
  const S42 = 10;
  const S43 = 15;
  const S44 = 21;
  x = convertToWordArray(utf8Encode(stringValue));
  a = 1732584193;
  b = 4023233417;
  c = 2562383102;
  d = 271733878;
  for (k = 0; k < x.length; k += 16) {
    AA = a;
    BB = b;
    CC = c;
    DD = d;
    a = FF(a, b, c, d, x[k + 0], S11, 3614090360);
    d = FF(d, a, b, c, x[k + 1], S12, 3905402710);
    c = FF(c, d, a, b, x[k + 2], S13, 606105819);
    b = FF(b, c, d, a, x[k + 3], S14, 3250441966);
    a = FF(a, b, c, d, x[k + 4], S11, 4118548399);
    d = FF(d, a, b, c, x[k + 5], S12, 1200080426);
    c = FF(c, d, a, b, x[k + 6], S13, 2821735955);
    b = FF(b, c, d, a, x[k + 7], S14, 4249261313);
    a = FF(a, b, c, d, x[k + 8], S11, 1770035416);
    d = FF(d, a, b, c, x[k + 9], S12, 2336552879);
    c = FF(c, d, a, b, x[k + 10], S13, 4294925233);
    b = FF(b, c, d, a, x[k + 11], S14, 2304563134);
    a = FF(a, b, c, d, x[k + 12], S11, 1804603682);
    d = FF(d, a, b, c, x[k + 13], S12, 4254626195);
    c = FF(c, d, a, b, x[k + 14], S13, 2792965006);
    b = FF(b, c, d, a, x[k + 15], S14, 1236535329);
    a = GG(a, b, c, d, x[k + 1], S21, 4129170786);
    d = GG(d, a, b, c, x[k + 6], S22, 3225465664);
    c = GG(c, d, a, b, x[k + 11], S23, 643717713);
    b = GG(b, c, d, a, x[k + 0], S24, 3921069994);
    a = GG(a, b, c, d, x[k + 5], S21, 3593408605);
    d = GG(d, a, b, c, x[k + 10], S22, 38016083);
    c = GG(c, d, a, b, x[k + 15], S23, 3634488961);
    b = GG(b, c, d, a, x[k + 4], S24, 3889429448);
    a = GG(a, b, c, d, x[k + 9], S21, 568446438);
    d = GG(d, a, b, c, x[k + 14], S22, 3275163606);
    c = GG(c, d, a, b, x[k + 3], S23, 4107603335);
    b = GG(b, c, d, a, x[k + 8], S24, 1163531501);
    a = GG(a, b, c, d, x[k + 13], S21, 2850285829);
    d = GG(d, a, b, c, x[k + 2], S22, 4243563512);
    c = GG(c, d, a, b, x[k + 7], S23, 1735328473);
    b = GG(b, c, d, a, x[k + 12], S24, 2368359562);
    a = HH(a, b, c, d, x[k + 5], S31, 4294588738);
    d = HH(d, a, b, c, x[k + 8], S32, 2272392833);
    c = HH(c, d, a, b, x[k + 11], S33, 1839030562);
    b = HH(b, c, d, a, x[k + 14], S34, 4259657740);
    a = HH(a, b, c, d, x[k + 1], S31, 2763975236);
    d = HH(d, a, b, c, x[k + 4], S32, 1272893353);
    c = HH(c, d, a, b, x[k + 7], S33, 4139469664);
    b = HH(b, c, d, a, x[k + 10], S34, 3200236656);
    a = HH(a, b, c, d, x[k + 13], S31, 681279174);
    d = HH(d, a, b, c, x[k + 0], S32, 3936430074);
    c = HH(c, d, a, b, x[k + 3], S33, 3572445317);
    b = HH(b, c, d, a, x[k + 6], S34, 76029189);
    a = HH(a, b, c, d, x[k + 9], S31, 3654602809);
    d = HH(d, a, b, c, x[k + 12], S32, 3873151461);
    c = HH(c, d, a, b, x[k + 15], S33, 530742520);
    b = HH(b, c, d, a, x[k + 2], S34, 3299628645);
    a = II(a, b, c, d, x[k + 0], S41, 4096336452);
    d = II(d, a, b, c, x[k + 7], S42, 1126891415);
    c = II(c, d, a, b, x[k + 14], S43, 2878612391);
    b = II(b, c, d, a, x[k + 5], S44, 4237533241);
    a = II(a, b, c, d, x[k + 12], S41, 1700485571);
    d = II(d, a, b, c, x[k + 3], S42, 2399980690);
    c = II(c, d, a, b, x[k + 10], S43, 4293915773);
    b = II(b, c, d, a, x[k + 1], S44, 2240044497);
    a = II(a, b, c, d, x[k + 8], S41, 1873313359);
    d = II(d, a, b, c, x[k + 15], S42, 4264355552);
    c = II(c, d, a, b, x[k + 6], S43, 2734768916);
    b = II(b, c, d, a, x[k + 13], S44, 1309151649);
    a = II(a, b, c, d, x[k + 4], S41, 4149444226);
    d = II(d, a, b, c, x[k + 11], S42, 3174756917);
    c = II(c, d, a, b, x[k + 2], S43, 718787259);
    b = II(b, c, d, a, x[k + 9], S44, 3951481745);
    a = addUnsigned(a, AA);
    b = addUnsigned(b, BB);
    c = addUnsigned(c, CC);
    d = addUnsigned(d, DD);
  }
  const temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);
  return temp.toLowerCase();
};

class NebulaSDKCore {
  // 构造函数触发通知回调队列
  constructor() {
    setTimeout(() => {
      this.circulateNotifyServer();
    }, 1e3);
  }
  // SDK版本号
  get version() {
    return "3.3.83";
  }
  // SDK环境标识
  get env() {
    return "production";
  }
  // SDK系统参数
  state = {
    debug: false,
    userInfoKey: "NEBULA_SDK_USER_INFO",
    deviceUniqueKey: "NEBULA_SDK_CORE_DEVICE_ID",
    circulateNotifyKey: "NEBULA_SDK_CORE_NOTIFY_LIST",
    circulateNotifyTimer: 0
  };
  // SDK运行参数
  options = null;
  // 获取调试模式状态
  get debug() {
    return this.state.debug;
  }
  // 设置调试模式状态
  set debug(value) {
    if (value) {
      console.warn([
        "调试信息：",
        `当前接入版本：${this.version}，有问题可先尝试更新最新版SDK`,
        "调试模式已开启，小程序正式版调试模式无效，上线后请务必将调试状态关闭！！！",
        "调试模式下调用方法或者属性会进行调试数据上报，用于对接状态查看和问题排查",
        "调试结果查看：星云开放平台 → 游戏中心 → 选择游戏 → 对接中心 → SDK 对接 → SDK 调试 → H5 → 小游戏 SDK → SDK 调试"
      ].join("\n"));
    }
    this.state.debug = value;
  }
  // 获取用户信息
  get userInfo() {
    return this.localStorage.getItem(this.state.userInfoKey);
  }
  // 设置用户信息
  set userInfo(userInfo) {
    this.localStorage.setItem(this.state.userInfoKey, userInfo);
  }
  // 微信小游戏OpenId
  get openId() {
    return this.userInfo?.openId ?? "";
  }
  // 微信小游戏UnionId
  get unionId() {
    return this.userInfo?.unionId ?? "";
  }
  // 获取通知回调队列
  get notifyList() {
    return this.localStorage.getItem(this.state.circulateNotifyKey) || [];
  }
  // 设置通知回调队列
  set notifyList(notifyInfo) {
    this.localStorage.setItem(this.state.circulateNotifyKey, notifyInfo);
  }
  // 通用参数序列化
  stringify(data, options) {
    const stringifyList = [];
    for (const key in data) {
      const value = data[key];
      if (value === null || value === void 0) continue;
      stringifyList.push(`${key}=${options?.encode ? encodeURIComponent(value) : value}`);
    }
    return stringifyList.join("&");
  }
  // 通用MD5加密
  calculateMD5Hex(value) {
    return md5(value);
  }
  // 设备唯一标识
  get deviceId() {
    const deviceId = this.localStorage.getItem(this.state.deviceUniqueKey);
    if (deviceId) return deviceId;
    const signValue = `${this.version}${this.getRandomValues().join("")}${Date.now()}`;
    const deviceRandomId = this.calculateMD5Hex(signValue);
    this.localStorage.setItem(this.state.deviceUniqueKey, deviceRandomId);
    return deviceRandomId;
  }
  // 随机字符串生成
  getRandomValues(length = 8) {
    const characterCodeList = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678";
    const characterValueList = [];
    for (let i = 0; i < length; i++) {
      const character = characterCodeList.charAt(
        Math.floor(Math.random() * characterCodeList.length)
      );
      characterValueList.push(character);
    }
    return characterValueList;
  }
  // 请求参数签名
  signature(singArgs, signKey) {
    const signNonce = this.getRandomValues().join("");
    const singValues = { ...singArgs, sign_type: "md5", sign_nonce: signNonce, sign_version: "1.0" };
    const signKeys = Object.keys(singValues).sort();
    const signValueList = Array.from(signKeys, (key) => {
      const value = singValues[key];
      if (value === null || value === void 0) return null;
      return `${key}=${typeof value === "object" ? JSON.stringify(value) : value}`;
    });
    const signStringValue = signValueList.filter((v) => v !== null).join("&");
    let signStringCode = encodeURIComponent(signStringValue);
    signStringCode = signStringCode.replace(/!/ug, "%21");
    signStringCode = signStringCode.replace(/\*/ug, "%2A");
    signStringCode = signStringCode.replace(/'/ug, "%27");
    signStringCode = signStringCode.replace(/\(/ug, "%28");
    signStringCode = signStringCode.replace(/\)/ug, "%29");
    singValues.sign = this.calculateMD5Hex(`${signStringCode}&${signKey}`);
    return singValues;
  }
  // 通用请求方法
  async request(args) {
    if (args.method === "GET") {
      return await this.httpRequest.get(args);
    }
    if (args.method === "POST") {
      return await this.httpRequest.post(args);
    }
    if (args.method === "PUT") {
      return await this.httpRequest.put(args);
    }
    if (args.method === "DELETE") {
      return await this.httpRequest.delete(args);
    }
    throw new Error("request method not support");
  }
  // 通知回调队列轮询
  async circulateNotifyServer(count = 1) {
    if (!this.support()) return;
    if (this.notifyList.length === 0) return;
    const successKeyList = await Promise.all(Array.from(this.notifyList, async (notifyItem) => {
      try {
        const { status } = await this.request(JSON.parse(notifyItem.value));
        return status === "error" ? notifyItem.key : null;
      } catch (error) {
        this.log({ code: -1, msg: "订单回调失败", data: error });
      }
    }));
    this.notifyList = this.notifyList.filter(({ key }) => successKeyList.includes(key));
    this.state.circulateNotifyTimer = setTimeout(() => {
      if (count > 10) {
        this.notifyList = [];
        return;
      }
      this.circulateNotifyServer(count + 1);
    }, count * 1e3);
  }
  // 请求账号服务
  async requestAccount(args) {
    args.url = `${"https://gate-nebula.737.com"}${args.url}`;
    return await this.request(args);
  }
  // 请求支付服务
  async requestPayment(args) {
    args.url = `${"https://api.feiyu.com"}${args.url}`;
    return await this.request(args);
  }
  // 请求聚合服务
  async requestCombine(args) {
    args.url = `${"https://api-combine.feiyu.com"}${args.url}`;
    return await this.request(args);
  }
  // 请求客服服务
  async requestService(args) {
    args.url = `${"https://cs-nebula.737.com"}${args.url}`;
    return await this.request(args);
  }
  // 请求通知回调
  async requestNotify(args) {
    const value = JSON.stringify(args);
    const key = this.calculateMD5Hex(value);
    this.notifyList = [...this.notifyList, { key, value }];
    clearTimeout(this.state.circulateNotifyTimer);
    await this.circulateNotifyServer();
  }
  // 请求调试服务
  async debugger(args) {
    if (!this.debug || !this.options) {
      return { status: "success", code: SDKStatusCode.Success, msg: "success", data: {} };
    }
    const response = {
      status: args.response?.status ?? "success",
      msg: args.response?.msg ?? "",
      status_text: args.response?.status === "error" ? "失败" : "成功",
      data: args.response?.data || ""
    };
    const data = {
      app_id: this.options.config.nbAppId,
      os: "5",
      work_id: this.deviceId,
      sdk: args.type,
      module: args.moudle,
      api: args.action,
      request: JSON.stringify(args.request),
      response: JSON.stringify(response),
      developer: args.deviceModel
    };
    return await this.httpRequest.post({
      url: `${"https://gate-nebula.737.com"}/open/sdkDebug/reportLog`,
      data: this.signature(data, this.options.config.nbAppKey)
    });
  }
  // 请求日志记录
  log(args) {
    console.warn(`NebulaSDK v${this.version}: ${args.code} - ${args.msg}`);
    if (!args.data) return;
    console.warn(JSON.stringify(args.data));
  }
  // 调试模式信息
  debugLog() {
    if (!this.debug) return;
    console.warn([
      "调试信息：",
      `游戏ID：nbAppId=${this.options?.config.nbAppId ?? ""}`,
      `渠道ID：nbChannelId=${this.options?.config.nbChannelId ?? ""}`,
      `渠道模板标识：nbChannelTemplateCode=${this.options?.config.nbChannelTemplateCode ?? ""}`,
      `通行证标识：passportCode=${this.options?.config.passportCode ?? ""}`,
      `支付标识：paymentCode=${this.options?.config.paymentCode ?? ""}`,
      "参数不存在请重新下载配置文件：星云开放平台 → 游戏中心 → 选择游戏 → 对接中心 → 渠道打包 → 渠道配置"
    ].join("\n"));
  }
  // 创建失败返回结果
  async createErrorActionResult(args, data) {
    this.log({ code: SDKStatusCode.Error, msg: "暂不支持该接口", data: args });
    return await Promise.resolve({ status: "error", code: SDKStatusCode.Error, msg: "暂不支持该接口", data });
  }
  // 创建成功返回结果
  async createSuccessActionResult(args, data) {
    this.log({ code: SDKStatusCode.Success, msg: "成功", data: args });
    return await Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "成功", data });
  }
  // 检测是否支持当前环境运行
  validateSupport() {
    if (this.support()) return { status: "success", code: SDKStatusCode.Success, msg: "成功", data: null };
    const supportResult = { status: "error", code: SDKStatusCode.NoSupport, msg: "当前环境无法运行NebulaSDK", data: null };
    this.log({ code: supportResult.code, msg: supportResult.msg, data: null });
    return supportResult;
  }
  // 检测是否初始化，初始化才可以调用SDK
  validateInit() {
    if (this.options) return { status: "success", code: SDKStatusCode.Success, msg: "成功", data: null };
    const initResult = { status: "error", code: SDKStatusCode.NoInit, msg: "请先调用init方法进行初始化", data: null };
    this.log({ code: initResult.code, msg: initResult.msg, data: null });
    return initResult;
  }
  // 检测是否登录，部分方法必须登录后才可以调用
  validateLogin() {
    if (this.userInfo) return { status: "success", code: SDKStatusCode.Success, msg: "成功", data: null };
    const loginResult = { status: "error", code: SDKStatusCode.NoLogin, msg: "请先调用login方法进行登录", data: null };
    this.log({ code: loginResult.code, msg: loginResult.msg, data: null });
    return loginResult;
  }
}

const request = async (options) => {
  return new Promise((resolve, reject) => {
    const task = wx.request({
      url: options.url,
      data: options.data,
      timeout: options.timeout,
      method: options.method ?? "GET",
      header: options.headers,
      success: (response) => {
        if (response.statusCode !== 200) {
          resolve({ status: "error", code: -1, msg: "error", data: response.data });
          return;
        }
        const data = response.data;
        const msg = data.message;
        if (data.status !== 0) {
          resolve({ status: "error", code: data.status, msg, data: response.data });
          return;
        }
        resolve({ status: "success", code: data.status, msg, data: data.data });
      },
      fail: (error) => {
        reject(error);
      },
      complete(error) {
        if (error?.errMsg !== "request:fail timeout") return;
        task.abort();
        console.warn("请求超时");
      }
    });
  });
};
const httpRequest = {
  get: async (options) => {
    return request({ ...options, method: "GET" });
  },
  post: async (options) => {
    return request({ ...options, method: "POST" });
  },
  put: async (options) => {
    return request({ ...options, method: "PUT" });
  },
  delete: async (options) => {
    return request({ ...options, method: "DELETE" });
  }
};

const localStorage = {
  getItem: (key) => {
    return wx.getStorageSync(key);
  },
  setItem: (key, value) => {
    wx.setStorageSync(key, value);
  },
  removeItem: (key) => {
    wx.removeStorageSync(key);
  },
  clear: () => {
    wx.clearStorageSync();
  }
};

class NebulaWeChatGameSDK extends NebulaSDKCore {
  // 本地数据存储器
  localStorage = localStorage;
  // Http请求管理
  httpRequest = httpRequest;
  // 进入游戏前台监听
  showLisetener = [];
  // 检查SDK是否支持当前环境运行
  support() {
    if (typeof wx === "undefined") return false;
    if (typeof GameGlobal === "undefined") return false;
    if (!wx.getDeviceInfo) return false;
    if (!wx.getStorageSync) return false;
    if (!wx.setStorageSync) return false;
    if (!wx.request) return false;
    return true;
  }
  // 获取渠道配置参数
  async getChannleConfig() {
    const { status, data } = await this.signatureRequestAccount({ url: "/pay/channelConfig/get", method: "GET" });
    if (status === "error") {
      this.log({ code: SDKStatusCode.ChannelConfigError, msg: "获取支付渠道配置失败", data });
      return null;
    }
    return {
      midasOfferId: data.param.midas_offer_id,
      midasExchangeRate: data.param.midas_exchange_rate ? Number(data.param.midas_exchange_rate) : 10,
      androidPayMode: data.param.android_pay_mode,
      iosPayMode: data.param.ios_pay_mode,
      macPayMode: data.param.mac_pay_mode,
      windowsPayMode: data.param.win_pay_mode,
      serviceImage: data.param.pay_guide_image,
      wxAppId: data.param.wx_app_id,
      androidClosePayGuide: data.param.android_close_pay_guide,
      iosClosePayGuide: data.param.ios_close_pay_guide,
      macClosePayGuide: data.param.mac_close_pay_guide,
      windowsClosePayGuide: data.param.win_close_pay_guide
    };
  }
  // 获取请求配置参数
  async getRequestConfig() {
    const { platform, model, system } = wx.getDeviceInfo();
    const { networkType } = await wx.getNetworkType();
    const newworkTypes = { "2g": 0, "3g": 0, "4g": 2, "5g": 3, wifi: 1, unknown: 0, none: 0 };
    const systemTypes = {
      android: 1,
      ios: 0,
      devtools: 2,
      windows: 2,
      mac: 2,
      ohos: 4
    };
    return {
      company_id: this.options.config.nbCompanyId,
      app_id: this.options.config.nbAppId,
      channel_id: this.options.config.nbChannelId,
      union_id: this.userInfo?.nbUnionId ?? "",
      open_id: this.userInfo?.nbOpenId ?? "",
      device_id: this.deviceId,
      startup_id: this.deviceId,
      payment_code: this.options.config.paymentCode,
      passport_code: this.options.config.passportCode,
      os: systemTypes[platform] ?? 2,
      network_mode: newworkTypes[networkType],
      device_type: model,
      os_version: system,
      sdk_version: this.version,
      timestamp: Math.floor(Date.now() / 1e3),
      is_debug: this.debug ? 1 : 0
    };
  }
  // 签名请求服务端账号接口
  async signatureRequestAccount(args) {
    const presetParams = await this.getRequestConfig();
    const requestParams = this.signature({ ...presetParams, ...args.data }, this.options.config.nbAppKey);
    return await this.requestAccount({ ...args, data: requestParams });
  }
  // 签名请求服务端支付接口
  async signatureRequestPayment(args) {
    const presetParams = await this.getRequestConfig();
    const requestParams = this.signature({ ...presetParams, ...args.data, source: "feiyu" }, this.options.config.appKey);
    return await this.requestPayment({ ...args, data: requestParams });
  }
  // 签名请求服务端聚合接口
  async signatureRequestCombine(args) {
    const presetParams = await this.getRequestConfig();
    const requestParams = this.signature({ ...presetParams, ...args.data }, this.options.config.nbAppKey);
    return await this.requestCombine({ ...args, data: requestParams });
  }
  // 全局调试上报信息
  async signatureRequestDebugger(args) {
    return { status: "success", code: SDKStatusCode.Success, msg: "success", data: null };
  }
  // 初始化
  async init(args) {
    if (typeof args.debug === "boolean") {
      this.debug = args.debug;
    }
    const supportResult = this.validateSupport();
    if (supportResult.status === "error") return Promise.resolve(supportResult);
    this.options = args;
    const initResult = { status: "success", code: SDKStatusCode.Success, msg: "初始化成功", data: args.config };
    this.debugLog();
    const showArgs = wx.getLaunchOptionsSync();
    this.showLisetener.forEach(({ callback }) => {
      callback(showArgs);
    });
    this.signatureRequestDebugger({ action: "init", request: args, response: initResult });
    return initResult;
  }
  // 获取微信小游戏登录Code
  async getWechatLoginCode(count = 1) {
    const getLoginCode = async () => {
      return await new Promise((resolve, reject) => {
        wx.login({
          success: (res) => {
            resolve(res.code);
          },
          fail: (error) => {
            reject(error);
          }
        });
      });
    };
    try {
      return await getLoginCode();
    } catch (error) {
      if (count > 5) throw error;
      return await this.getWechatLoginCode(count + 1);
    }
  }
  // 登录
  async login() {
    const supportResult = this.validateSupport();
    if (supportResult.status === "error") return supportResult;
    const initResult = this.validateInit();
    if (initResult.status === "error") return initResult;
    const loginCode = await this.getWechatLoginCode();
    const { status, code, msg, data } = await this.signatureRequestAccount({
      url: "/account/user/detail",
      method: "POST",
      data: { game_version: this.options.version, user_id: "0", code: loginCode, passport_code: this.options.config.passportCode }
    });
    if (code === 2100607) {
      const { confirm } = await wx.showModal({ title: "提示", content: msg, cancelText: "退出", confirmText: "联系客服" });
      if (confirm) {
        const serviceResult = await this.openCustomerServiceConversation({});
        if (serviceResult.status === "error") return serviceResult;
      }
      return { status: "error", code: SDKStatusCode.LoginFreezeError, msg: "登录失败", data: null };
    }
    if (status === "error") {
      this.log({ code: SDKStatusCode.LoginError, msg: "登录失败", data });
      return { status: "error", code: SDKStatusCode.LoginError, msg: "登录失败", data: null };
    }
    this.userInfo = {
      openId: data.user.user_id,
      unionId: data.user.u_id,
      token: data.token,
      nbOpenId: data.open_id,
      nbUnionId: data.union_id,
      firstLogin: data.first_login === 1
    };
    const loginResult = {
      status: "success",
      code: SDKStatusCode.Success,
      msg: "登录成功",
      data: { ...this.userInfo, nbOpendId: data.open_id }
    };
    this.signatureRequestDebugger({ action: "login", request: null, response: loginResult });
    return loginResult;
  }
  // 创建聚合支付订单
  async createAggregatePayOrder(args) {
    const { status, code, msg, data } = await this.signatureRequestAccount({
      url: "/pay/order/create",
      method: "POST",
      data: {
        pay_amount: args.goodsPrice,
        game_order_id: args.tradeNo,
        goods_id: args.goodsId,
        goods_name: args.goodsName,
        game_version: this.options?.version,
        player_id: args.playerId,
        role_id: this.calculateMD5Hex(args.serverId + args.playerId),
        player_name: args.playerName,
        player_level: args.playerLevel,
        vip_level: args.vipLevel ?? 0,
        server_id: args.serverId,
        user_id: this.userInfo?.openId,
        open_id: this.userInfo?.nbOpenId,
        union_id: this.userInfo?.nbUnionId,
        data_version: "1",
        pay_sign_type: "md5",
        notify_url: args.notifyUrl,
        notify_ext: args.notifyExt,
        payment_channel: args.payType,
        channel_ext: args.channelExt
      }
    });
    if (status === "error") {
      this.log({ code: SDKStatusCode.AggrateOrderError, msg: "创建聚合订单失败", data });
      const errorCodes = {
        2120143: SDKStatusCode.AccounteExceptionError,
        2120144: SDKStatusCode.DeviceExceptionError,
        2120147: SDKStatusCode.CreateExceptionError,
        2120148: SDKStatusCode.PayAccountFreezeError
      };
      if (errorCodes[code] === SDKStatusCode.PayAccountFreezeError) {
        await wx.showModal({ title: "提示", content: msg, showCancel: false });
      }
      return { code: errorCodes[code] ?? SDKStatusCode.AggrateOrderError, orderNo: "", notifyUrl: "", data };
    }
    return { code: SDKStatusCode.Success, orderNo: data.order_id, notifyUrl: data.notify_url, data };
  }
  // 创建预支付订单
  async createPresetPayOrder(args) {
    const { status, data } = await this.signatureRequestPayment({
      url: "/pay/order",
      method: "POST",
      data: {
        pay_amount: args.goodsPrice,
        goods_id: args.goodsId,
        goods_name: args.goodsName,
        app_order_id: args.orderNo,
        app_callback_uri: args.notifyUrl,
        enable_alipay: 0,
        enable_wxpay: 0,
        param_ext: args.ext ? JSON.stringify(args.ext) : ""
      }
    });
    if (status === "error") {
      this.log({ code: SDKStatusCode.PresetOrderError, msg: "创建预下单失败", data });
      return { code: SDKStatusCode.PresetOrderError, orderNo: "", notifyUrl: "", data };
    }
    return { code: SDKStatusCode.Success, orderNo: data.order_id, notifyUrl: args.notifyUrl, data };
  }
  // 创建JSAPI扫码支付订单
  async createJSApiScanCodePayOrder(args) {
    const { status, data } = await this.signatureRequestPayment({
      url: "/pay/wxpay/miniJsapiQrCode",
      method: "GET",
      data: { order_id: args.orderNo }
    });
    if (status === "error") {
      this.log({ code: SDKStatusCode.ScanCodeOrderError, msg: "创建扫码订单失败", data });
      return { code: SDKStatusCode.ScanCodeOrderError, orderNo: "", orderPayUrl: "", data };
    }
    const commonParams = await this.getRequestConfig();
    const codeParams = { order_id: args.orderNo, qr_code: data.qr_code, expire_at: data.expire_at };
    const params = this.signature({ ...commonParams, ...codeParams, source: "feiyu" }, this.options.config.appKey);
    return {
      code: SDKStatusCode.Success,
      orderNo: args.orderNo,
      orderPayUrl: `${"https://api.feiyu.com"}/pay/wxpay/genQrCodeImage?${this.stringify(params, { encode: true })}`,
      data
    };
  }
  // 创建H5扫码支付订单
  async createH5ScanCodePayOrder(args) {
    const { status, data } = await this.signatureRequestPayment({
      url: "/pay/wxpay/miniPC",
      method: "POST",
      data: { order_id: args.orderNo }
    });
    if (status === "error") {
      this.log({ code: SDKStatusCode.ScanCodeOrderError, msg: "创建扫码订单失败", data });
      return { code: SDKStatusCode.ScanCodeOrderError, orderNo: "", orderPayUrl: "", data };
    }
    const commonParams = await this.getRequestConfig();
    const codeParams = { order_id: args.orderNo, qr_code: data.qr_code, expire_at: data.expire_at };
    const params = this.signature({ ...commonParams, ...codeParams, source: "feiyu" }, this.options.config.appKey);
    return {
      code: SDKStatusCode.Success,
      orderNo: args.orderNo,
      orderPayUrl: `${"https://api.feiyu.com"}/pay/wxpay/genQrCodeImage?${this.stringify(params, { encode: true })}`,
      data
    };
  }
  // 微信游戏币支付模式
  async wechatMidasGamePay(args) {
    const [aggrate, config] = await Promise.all([
      this.createAggregatePayOrder({ ...args, payType: 0 }),
      this.getChannleConfig()
    ]);
    if (aggrate.code !== SDKStatusCode.Success) return { status: "error", code: aggrate.code, msg: "支付失败", data: null };
    if (!config) return { status: "error", code: SDKStatusCode.PayGameCurrencyError, msg: "支付失败", data: null };
    try {
      await wx.requestMidasPayment({
        mode: "game",
        env: args.sandbox,
        offerId: config.midasOfferId,
        currencyType: "CNY",
        buyQuantity: args.goodsPrice / 100 * config.midasExchangeRate,
        zoneId: args.zoneId,
        outTradeNo: aggrate.orderNo
      });
      const notifyInfo = this.signature({
        order_id: aggrate.orderNo,
        channel_order_id: args.tradeNo,
        amount: args.goodsPrice,
        sandbox: args.sandbox,
        channel_ext: JSON.stringify({
          zone_id: args.zoneId,
          openid: this.userInfo?.openId,
          unionid: this.userInfo?.unionId,
          pf: 2
        })
      }, this.options.config.nbAppKey);
      this.requestNotify({ url: aggrate.notifyUrl, method: "POST", data: notifyInfo });
      return { status: "success", code: SDKStatusCode.Success, msg: "支付成功", data: { payType: SDKPayType.Natve, orderNo: aggrate.orderNo } };
    } catch (error) {
      this.log({ code: SDKStatusCode.PayGameCurrencyError, msg: "微信游戏币支付失败", data: error });
      return { status: "error", code: SDKStatusCode.PayGameCurrencyError, msg: "支付失败", data: null };
    }
  }
  // 微信直购支付模式
  async wechatMidasGoodPay(args) {
    const channel_ext = JSON.stringify({ env: args.sandbox, platform: "android", zone_id: args.zoneId, openid: this.userInfo?.openId });
    const [aggrate, config] = await Promise.all([
      this.createAggregatePayOrder({ ...args, payType: 0, channelExt: channel_ext }),
      this.getChannleConfig()
    ]);
    if (aggrate.code !== SDKStatusCode.Success) return { status: "error", code: aggrate.code, msg: "支付失败", data: null };
    if (!config) return { status: "error", code: SDKStatusCode.PayGoodsDirectError, msg: "支付失败", data: null };
    return await new Promise((resolve) => {
      const wechatGameApi = wx;
      if (!wechatGameApi.requestMidasPaymentGameItem) {
        resolve({ status: "error", code: SDKStatusCode.PayGoodsDirectError, msg: "微信版本过低无法支付", data: null });
        return;
      }
      const requestNotifyServer = async () => {
        const commonParams = await this.getRequestConfig();
        const notifyParams = {
          order_id: aggrate.orderNo,
          channel_order_id: args.tradeNo,
          amount: args.goodsPrice,
          sandbox: args.sandbox,
          notify_status: 0,
          notify_source: 1,
          channel_ext: JSON.stringify({
            openid: this.userInfo?.openId,
            productId: args.goodsId,
            errCode: ""
          })
        };
        this.requestNotify({
          url: aggrate.notifyUrl,
          method: "POST",
          data: this.signature({ ...commonParams, ...notifyParams }, this.options.config.nbAppKey)
        });
      };
      wechatGameApi.requestMidasPaymentGameItem({
        signData: aggrate.data.sign_data,
        paySig: aggrate.data.pay_sig,
        signature: aggrate.data.signature,
        success: () => {
          setTimeout(() => {
            requestNotifyServer();
          }, 0);
          resolve({ status: "success", code: SDKStatusCode.Success, msg: "支付成功", data: { payType: SDKPayType.Natve, orderNo: aggrate.orderNo } });
        },
        fail: (error) => {
          this.log({ code: SDKStatusCode.PayGoodsDirectError, msg: "微信直购支付失败", data: error });
          resolve({ status: "error", code: SDKStatusCode.PayGoodsDirectError, msg: "支付失败", data: null });
        }
      });
    });
  }
  // 微信内购支付
  async wechatMidasPay(args) {
    if (this.options?.config.paymentCode === "wechatgame") {
      return await this.wechatMidasGamePay(args);
    }
    if (this.options?.config.paymentCode === "wechatgamedirect") {
      return await this.wechatMidasGoodPay(args);
    }
    return { status: "error", code: SDKStatusCode.PayError, msg: "该渠道支付方式暂未支持", data: null };
  }
  // 微信客服支付
  async wechatServicePay(args) {
    const { cancel } = await wx.showModal({
      content: "请进入客服会话充值，如果未收到本订单支付入口，请在客服会话中发送“cz”或“充值”或点击右下角图片获取",
      confirmText: "去充值"
    });
    if (cancel) return { status: "error", code: SDKStatusCode.PayServiceCancelError, msg: "支付失败", data: null };
    const aggrate = await this.createAggregatePayOrder({ ...args, payType: 1 });
    if (aggrate.code !== SDKStatusCode.Success) return { status: "error", code: aggrate.code, msg: "支付失败", data: null };
    const config = await this.getChannleConfig();
    if (!config) return { status: "error", code: SDKStatusCode.ChannelConfigError, msg: "支付失败", data: null };
    const presetExt = { wxpay_app_id: config.wxAppId, wxpay_open_id: this.userInfo?.openId };
    const presetArgs = Object.assign(args, aggrate, { ext: presetExt });
    const preset = await this.createPresetPayOrder(presetArgs);
    if (!preset) return { status: "error", code: SDKStatusCode.PresetOrderError, msg: "支付失败", data: null };
    try {
      await wx.openCustomerServiceConversation({
        sessionFrom: this.stringify({
          version: this.version,
          title: "点我进行充值",
          description: `点我充值${(args.goodsPrice / 100).toFixed(2)}元`,
          app_id: this.options?.config.nbAppId,
          channel_id: this.options?.config.nbChannelId,
          order_id: preset.orderNo,
          env: "production",
          path: "/wechat-mini-game",
          pay_amount: args.goodsPrice
        }),
        showMessageCard: true,
        sendMessageTitle: `我要充值${args.goodsPrice / 100}元`,
        sendMessageImg: config.serviceImage
      });
      return { status: "success", code: SDKStatusCode.Success, msg: "打开客服会话成功", data: { payType: SDKPayType.Service, orderNo: preset.orderNo } };
    } catch (error) {
      if (error.errMsg === "openCustomerServiceConversation:fail cancel") {
        return { status: "error", code: SDKStatusCode.PayServiceCancelError, msg: "取消支付", data: null };
      }
      return { status: "error", code: SDKStatusCode.PayServiceError, msg: "打开客服会话失败", data: null };
    }
  }
  // 微信扫码支付
  async wechatScanCodePay(args) {
    const [aggrate, config] = await Promise.all([
      this.createAggregatePayOrder({ ...args, payType: 1 }),
      this.getChannleConfig()
    ]);
    if (!config) return { status: "error", code: SDKStatusCode.ChannelConfigError, msg: "获取支付渠道配置失败", data: null };
    if (aggrate.code !== SDKStatusCode.Success) return { status: "error", code: aggrate.code, msg: "支付失败", data: null };
    const state = { orderUrl: "", orderNo: "" };
    const { platform } = wx.getDeviceInfo();
    if (platform === "ios" || platform === "android") {
      const presetExt = { wxpay_app_id: config.wxAppId, wxpay_open_id: this.userInfo?.openId };
      const presetArgs = Object.assign(args, aggrate, { ext: presetExt });
      const preset = await this.createPresetPayOrder(presetArgs);
      if (!preset) return { status: "error", code: SDKStatusCode.PresetOrderError, msg: "支付失败", data: null };
      const scanCodeResult = await this.createJSApiScanCodePayOrder({ ...args, ...preset });
      if (!scanCodeResult) return { status: "error", code: SDKStatusCode.ScanCodeOrderError, msg: "支付失败", data: null };
      state.orderNo = scanCodeResult.orderNo;
      state.orderUrl = scanCodeResult.orderPayUrl;
    } else {
      const preset = await this.createPresetPayOrder({ ...args, ...aggrate });
      if (!preset) return { status: "error", code: SDKStatusCode.PresetOrderError, msg: "支付失败", data: null };
      const scanCodeResult = await this.createH5ScanCodePayOrder({ ...args, ...preset });
      if (!scanCodeResult) return { status: "error", code: SDKStatusCode.ScanCodeOrderError, msg: "支付失败", data: null };
      state.orderNo = scanCodeResult.orderNo;
      state.orderUrl = scanCodeResult.orderPayUrl;
    }
    await wx.previewImage({ urls: [state.orderUrl] });
    return { status: "success", code: SDKStatusCode.Success, msg: "支付成功", data: { payType: SDKPayType.QRCode, orderNo: state.orderNo } };
  }
  // 默认关闭支付
  async defaultClosePay(msg) {
    await wx.showModal({
      content: msg || "由于相关规范，暂不提供充值服务",
      showCancel: false,
      confirmText: "好的"
    });
    return { status: "error", code: SDKStatusCode.PayCloseError, msg: "支付失败", data: null };
  }
  // 安卓支付方式
  async androidPayAction(args, config) {
    switch (config.androidPayMode) {
      case "0":
        return this.defaultClosePay(config.androidClosePayGuide);
      case "1":
        return this.wechatMidasPay(args);
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay(config.androidClosePayGuide);
    }
  }
  // 鸿蒙支付方式
  async harmonyPayAction(args) {
    return this.wechatMidasPay(args);
  }
  // 苹果支付方式
  async iosPayAction(args, config) {
    switch (config.iosPayMode) {
      case "0":
        return this.defaultClosePay(config.iosClosePayGuide);
      case "1":
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay(config.iosClosePayGuide);
    }
  }
  // Mac支付方式
  async macPayAction(args, config) {
    switch (config.macPayMode) {
      case "0":
        return this.defaultClosePay(config.macClosePayGuide);
      case "1":
        return this.wechatMidasPay(args);
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay(config.macClosePayGuide);
    }
  }
  // Windows支付方式
  async windowsPayAction(args, config) {
    switch (config.windowsPayMode) {
      case "0":
        return this.defaultClosePay(config.windowsClosePayGuide);
      case "1":
        return this.wechatMidasPay(args);
      case "2":
        return this.wechatServicePay(args);
      case "3":
        return this.wechatScanCodePay(args);
      default:
        return this.defaultClosePay(config.windowsClosePayGuide);
    }
  }
  // 开发者工具支付方式
  async devtoolsPayAction(args) {
    if (this.debug) {
      console.warn([
        "调试信息：",
        "当前在开发者工具下可以选择不同支付方式进行支付，移动端访问会根据平台和配置自动调用支付方式",
        "微信内购原生支付必须商品ID和商品价格与微信后台一致否则无法拉起支付",
        "客服支付跳转到客服后结果返回成功，跳转到客服已经离开的游戏无法检测用户是否支付",
        "扫码支付生成二维码后结果返回成功，弹出二维码无法检测用户是否进行扫码支付",
        "方法调用成功都会返回支付订单号和支付类型，支付成功状态主要以服务端通知为基准",
        "不同的支付方式根据返回值payType进行处理，支付类型：1=原生支付、2=客服支付、3=二维码支付"
      ].join("\n"));
    }
    try {
      const { tapIndex } = await wx.showActionSheet({
        alertText: "选择支付方式",
        itemList: ["内购支付", "客服支付", "扫码支付", "关闭支付"]
      });
      switch (tapIndex) {
        case 0:
          return this.wechatMidasPay(args);
        case 1:
          return this.wechatServicePay(args);
        case 2:
          return this.wechatScanCodePay(args);
        case 3:
          return this.defaultClosePay("由于相关规范，暂不提供充值服务");
        default:
          return this.defaultClosePay("由于相关规范，暂不提供充值服务");
      }
    } catch (error) {
      this.log({ code: SDKStatusCode.PayError, msg: "支付失败", data: error });
      return { status: "error", code: SDKStatusCode.PayError, msg: "支付失败", data: null };
    }
  }
  // 支付
  async pay(args) {
    const supportResult = this.validateSupport();
    if (supportResult.status === "error") return supportResult;
    const initResult = this.validateInit();
    if (initResult.status === "error") return initResult;
    const loginResult = this.validateLogin();
    if (loginResult.status === "error") return loginResult;
    const config = await this.getChannleConfig();
    if (!config) return { status: "error", code: SDKStatusCode.ChannelConfigError, msg: "获取支付渠道配置失败", data: null };
    const { errMsg } = await wx.checkSession();
    if (errMsg !== "checkSession:ok") {
      await this.login();
    }
    const deviceInfo = wx.getDeviceInfo();
    let payResult;
    if (deviceInfo.platform === "android") {
      payResult = await this.androidPayAction(args, config);
    } else if (deviceInfo.platform === "ohos") {
      payResult = await this.harmonyPayAction(args);
    } else if (deviceInfo.platform === "ios") {
      payResult = await this.iosPayAction(args, config);
    } else if (deviceInfo.platform === "mac") {
      payResult = await this.macPayAction(args, config);
    } else if (deviceInfo.platform === "windows") {
      payResult = await this.windowsPayAction(args, config);
    } else if (deviceInfo.platform === "devtools") {
      payResult = await this.devtoolsPayAction(args);
    } else {
      payResult = await this.defaultClosePay("由于相关规范，暂不提供充值服务");
    }
    this.signatureRequestDebugger({ action: "pay", request: args, response: payResult });
    return payResult;
  }
  // 打开游戏客服
  async openCustomerServiceConversation(args) {
    try {
      await wx.openCustomerServiceConversation(args);
      this.signatureRequestDebugger({ action: "openCustomerServiceConversation", request: args, response: null });
      return { status: "success", code: SDKStatusCode.Success, msg: "打开客服成功", data: null };
    } catch (error) {
      this.log({ code: SDKStatusCode.ServiceError, msg: "打开客服失败", data: error });
      const code = error?.errMsg === "openCustomerServiceConversation:fail cancel" ? SDKStatusCode.ServiceCancelError : SDKStatusCode.ServiceError;
      return { status: "success", code, msg: "打开客服失败", data: error };
    }
  }
  // 创建游戏圈按钮
  async createGameClubButton(args) {
    const gameClubButton = wx.createGameClubButton(args);
    this.signatureRequestDebugger({ action: "createGameClubButton", request: args, response: null });
    return Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "创建游戏圈成功", data: { gameClubButton } });
  }
  // 创建激励广告
  async createRewardedVideoAd(args) {
    return await new Promise((resolve) => {
      const rewardedVideoAd = wx.createRewardedVideoAd(args);
      rewardedVideoAd.offLoad();
      rewardedVideoAd.onLoad(() => {
        resolve({
          status: "success",
          code: SDKStatusCode.Success,
          msg: "创建激励视频广告成功",
          data: { rewardedVideoAd }
        });
      });
      rewardedVideoAd.offError();
      rewardedVideoAd.onError((error) => {
        this.log({ code: SDKStatusCode.RewardedVideoAdError, msg: "创建激励视频广告失败", data: error });
        resolve({ status: "error", code: SDKStatusCode.RewardedVideoAdError, msg: "创建激励视频广告失败", data: { rewardedVideoAd: null } });
      });
      rewardedVideoAd.load().then(() => {
        resolve({
          status: "success",
          code: SDKStatusCode.Success,
          msg: "创建激励视频广告成功",
          data: { rewardedVideoAd }
        });
      }).catch((error) => {
        this.log({ code: SDKStatusCode.RewardedVideoAdError, msg: "创建激励视频广告失败", data: error });
        resolve({ status: "error", code: SDKStatusCode.RewardedVideoAdError, msg: "创建激励视频广告失败", data: { rewardedVideoAd: null } });
      });
      this.signatureRequestDebugger({ action: "createRewardedVideoAd", request: args, response: null });
    });
  }
  async createBannerAd(args) {
    return await new Promise((resolve) => {
      const bannerAd = wx.createBannerAd(args);
      bannerAd.onLoad(() => {
        resolve({ status: "success", code: SDKStatusCode.Success, msg: "创建Banner广告成功", data: { bannerAd } });
      });
      bannerAd.onError((error) => {
        this.log({ code: SDKStatusCode.BannerAdError, msg: "创建Banner广告失败", data: error });
        resolve({ status: "error", code: SDKStatusCode.BannerAdError, msg: "创建Banner广告失败", data: { bannerAd: null } });
      });
      this.signatureRequestDebugger({ action: "createBannerAd", request: args, response: null });
    });
  }
  async createInterstitialAd(args) {
    return await new Promise((resolve) => {
      const interstitialAd = wx.createInterstitialAd(args);
      interstitialAd.onLoad(() => {
        resolve({ status: "success", code: SDKStatusCode.Success, msg: "创建插屏广告成功", data: { interstitialAd } });
      });
      interstitialAd.onError((error) => {
        this.log({ code: SDKStatusCode.InterstitialAdError, msg: "创建插屏广告失败", data: error });
        resolve({ status: "error", code: SDKStatusCode.InterstitialAdError, msg: "创建插屏广告失败", data: { interstitialAd: null } });
      });
      interstitialAd.load();
      this.signatureRequestDebugger({ action: "createInterstitialAd", request: args, response: null });
    });
  }
  async createCustomAd(args) {
    return await new Promise((resolve) => {
      const customAd = wx.createCustomAd(args);
      customAd.onLoad(() => {
        resolve({
          status: "success",
          code: SDKStatusCode.Success,
          msg: "创建自定义广告成功",
          data: { customAd }
        });
      });
      customAd.onError((error) => {
        this.log({ code: SDKStatusCode.CustomAdError, msg: "创建自定义广告失败", data: error });
        resolve({ status: "error", code: SDKStatusCode.CustomAdError, msg: "创建自定义广告失败", data: { customAd: null } });
      });
      this.signatureRequestDebugger({ action: "createCustomAd", request: args, response: null });
    });
  }
  async getSurveyInfo(args) {
    const { status, data } = await this.signatureRequestCombine({
      url: "/v1/wechatMiniGame/tencentSurvey/get",
      method: "POST",
      data: { survey_id: args.surveyId, server_id: args.serverId }
    });
    if (status === "error" || !data) {
      this.log({ code: SDKStatusCode.SurveyError, msg: "获取问卷失败", data });
      return null;
    }
    return { id: data.id, title: data.title, sid: data.sid, hash: data.hash, link: data.link };
  }
  // 创建问卷
  async createSurvey(args) {
    const surveyInfo = await this.getSurveyInfo(args);
    if (!surveyInfo) return { status: "error", code: SDKStatusCode.SurveyError, msg: "创建问卷失败", data: { survey: null } };
    let surveyCallbackList = [];
    const survey = {
      data: surveyInfo,
      show: async () => {
        const showSurveyInfo = await this.getSurveyInfo(args);
        if (!showSurveyInfo) throw new Error("get survey info error");
        const page = "pages/survey/index";
        const query = this.stringify({
          sid: showSurveyInfo.sid,
          hash: showSurveyInfo.hash,
          navigateBackMiniProgram: true,
          ...args.surveyQuery
        });
        await wx.navigateToMiniProgram({ appId: "wxebadf544ddae62cb", path: `${page}?${query}` });
      },
      onClose: (closeCallback) => {
        const showCallback = (options) => {
          if (options.scene !== 1038 || options.referrerInfo.appId !== "wxebadf544ddae62cb") return;
          closeCallback(options.referrerInfo.extraData || {});
          survey.offClose(closeCallback);
          this.signatureRequestDebugger({
            action: "createSurvey",
            request: args,
            response: { status: "success", data: surveyInfo, code: SDKStatusCode.Success, msg: "" }
          });
        };
        surveyCallbackList.push({ closeCallback, showCallback });
        wx.onShow(showCallback);
      },
      offClose: (closeCallback) => {
        surveyCallbackList.forEach((surveyCallback) => {
          if (closeCallback && closeCallback !== surveyCallback.closeCallback) return;
          wx.offShow(surveyCallback.showCallback);
        });
        surveyCallbackList = surveyCallbackList.filter((surveyCallback) => {
          if (!closeCallback) return true;
          return surveyCallback.closeCallback === closeCallback;
        });
      }
    };
    return { status: "success", code: SDKStatusCode.Success, msg: "创建问卷成功", data: { survey } };
  }
  // 订阅消息
  async requestSubscribeMessage(args) {
    try {
      const subscribeResult = await wx.requestSubscribeMessage(args);
      const openSetting = await wx.getSetting({ withSubscriptions: true });
      const templateList = Array.from(args.tmplIds, (tmplId) => {
        return {
          tmplId,
          always: !!openSetting.subscriptionsSetting?.itemSettings?.[tmplId],
          status: subscribeResult[tmplId] || "reject"
        };
      });
      const templateResult = await this.signatureRequestCombine({
        url: "/v1/wechatMiniGame/template/access",
        method: "POST",
        data: { template_ids: templateList.filter((template) => template.status === "accept").map((template) => template.tmplId) }
      });
      if (templateResult.status === "error") {
        return { status: "error", code: SDKStatusCode.SubscribeMessageReportError, msg: "订阅消息上报失败", data: templateList };
      }
      this.signatureRequestDebugger({ action: "requestSubscribeMessage", request: args, response: templateResult });
      return { status: "success", code: SDKStatusCode.Success, msg: "订阅消息成功", data: templateList };
    } catch (error) {
      this.log({ code: SDKStatusCode.SubscribeMessageError, msg: "订阅消息失败", data: error });
      return { status: "error", code: SDKStatusCode.SubscribeMessageError, msg: "订阅消息失败", data: [] };
    }
  }
  // 添加桌面快捷方式
  async addShortcut() {
    return await this.createErrorActionResult(null, false);
  }
  // 跳转到侧边栏
  async navigateToSidebar() {
    return await this.createErrorActionResult(null, null);
  }
  // 显示分享菜单
  async showShareMenu(args) {
    try {
      await wx.showShareMenu(args);
      this.signatureRequestDebugger({ action: "showShareMenu", request: args, response: null });
      return { status: "success", code: SDKStatusCode.Success, msg: "显示分享菜单成功", data: null };
    } catch (error) {
      this.log({ code: SDKStatusCode.ShowShareMenuError, msg: "显示分享菜单失败", data: error });
      return { status: "error", code: SDKStatusCode.ShowShareMenuError, msg: "显示分享菜单失败", data: null };
    }
  }
  // 隐藏分享菜单
  async hideShareMenu(args) {
    try {
      await wx.hideShareMenu(args);
      this.signatureRequestDebugger({ action: "hideShareMenu", request: args, response: null });
      return { status: "success", code: SDKStatusCode.Success, msg: "隐藏分享菜单成功", data: null };
    } catch (error) {
      this.log({ code: SDKStatusCode.HideShareMenuError, msg: "隐藏分享菜单失败", data: error });
      return { status: "error", code: SDKStatusCode.HideShareMenuError, msg: "隐藏分享菜单失败", data: null };
    }
  }
  // 获取星云分享卡片信息
  async getShareMessageCard(id) {
    const { status, data } = await this.signatureRequestCombine({
      url: "/v1/wechatMiniGame/shareCard/get",
      method: "POST",
      data: { card_id: id }
    });
    if (status === "error") {
      this.log({ code: SDKStatusCode.ShareMessageCardError, msg: "获取分享卡片信息失败", data });
      return null;
    }
    if (!data) {
      this.log({ code: SDKStatusCode.ShareMessageCardError, msg: "获取分享卡片信息失败", data });
      return { title: "", imageUrl: "", imageUrlId: "" };
    }
    return { title: data.title, imageUrl: data.image_url, imageUrlId: data.image_url_id };
  }
  // 定向分享消息
  async shareAppMessage(args) {
    const shareArgs = args;
    if (args.messageCardId) {
      const messageCard = await this.getShareMessageCard(args.messageCardId);
      if (!messageCard) return { status: "error", code: SDKStatusCode.ShareMessageCardError, msg: "获取分享卡片失败", data: null };
      shareArgs.title = shareArgs.title ?? messageCard.title;
      shareArgs.imageUrl = shareArgs.imageUrl ?? messageCard.imageUrl;
      shareArgs.imageUrlId = shareArgs.imageUrlId ?? messageCard.imageUrlId;
    }
    try {
      wx.shareAppMessage(shareArgs);
      this.signatureRequestDebugger({ action: "shareAppMessage", request: args, response: null });
      return { status: "success", code: SDKStatusCode.Success, msg: "分享消息成功", data: null };
    } catch (error) {
      this.log({ code: SDKStatusCode.ShareAppMessageError, msg: "分享消息失败", data: error });
      return { status: "error", code: SDKStatusCode.ShareAppMessageError, msg: "分享消息失败", data: null };
    }
  }
  // 绑定全局分享消息
  async onShareAppMessage(args) {
    const createShareArgs = async () => {
      const shareArgs = typeof args === "function" ? args() : args;
      if (shareArgs.messageCardId) {
        const messageCard = await this.getShareMessageCard(shareArgs.messageCardId);
        if (!messageCard) return { status: "error", code: SDKStatusCode.ShareMessageCardError, msg: "获取分享配置失败", data: null };
        shareArgs.title = shareArgs.title ?? messageCard.title;
        shareArgs.imageUrl = shareArgs.imageUrl ?? messageCard.imageUrl;
        shareArgs.imageUrlId = shareArgs.imageUrlId ?? messageCard.imageUrlId;
      }
      return shareArgs;
    };
    try {
      wx.onShareAppMessage(() => ({ promise: createShareArgs() }));
      this.signatureRequestDebugger({ action: "onShareAppMessage", request: args, response: null });
      return Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "绑定分享消息成功", data: null });
    } catch (error) {
      this.log({ code: SDKStatusCode.OnShareAppMessageError, msg: "绑定分享消息失败", data: error });
      return { status: "error", code: SDKStatusCode.OnShareAppMessageError, msg: "绑定分享消息失败", data: null };
    }
  }
  // 解绑全局分享消息
  async offShareAppMessage(args) {
    try {
      wx.offShareAppMessage(typeof args === "function" ? args : void 0);
      this.signatureRequestDebugger({ action: "offShareAppMessage", request: args, response: null });
      return Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "解绑分享消息成功", data: null });
    } catch (error) {
      this.log({ code: SDKStatusCode.OffShareAppMessageError, msg: "解绑分享消息成功", data: error });
      return { status: "error", code: SDKStatusCode.OffShareAppMessageError, msg: "解绑分享消息成功", data: null };
    }
  }
  // 绑定进入游戏前台
  async onShow(args) {
    const showLisetenerCallback = (options) => {
      options.supportSideBar = false;
      options.fromSideBar = false;
      options.supportShortcut = false;
      options.fromShortcut = false;
      args(options);
    };
    this.showLisetener.push({ listener: args, callback: showLisetenerCallback });
    wx.onShow(showLisetenerCallback);
    return Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "绑定进入游戏前台成功", data: null });
  }
  // 解绑进入游戏前台
  async offShow(args) {
    const showLisetenerCallback = this.showLisetener.find((showLisetener) => showLisetener.listener === args);
    if (showLisetenerCallback) {
      wx.offShow(showLisetenerCallback.callback);
    }
    return Promise.resolve({ status: "success", code: SDKStatusCode.Success, msg: "解绑进入游戏前台成功", data: null });
  }
}
const nebulaSDKInstance = new NebulaWeChatGameSDK();
{
  const gameGlobalState = { surveyList: [] };
  GameGlobal.NebulaUnityDebug = (debug) => {
    nebulaSDKInstance.debug = Boolean(debug);
  };
  GameGlobal.NebulaUnityInit = async (args) => {
    if (typeof args.config === "string") {
      args.config = JSON.parse(args.config);
    }
    const initResult = await nebulaSDKInstance.init(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKInitCallback", JSON.stringify(initResult));
  };
  GameGlobal.NebulaUnityLogin = async () => {
    const loginResult = await nebulaSDKInstance.login();
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKLoginCallback", JSON.stringify(loginResult));
  };
  GameGlobal.NebulaUnityPay = async (args) => {
    const PayResult = await nebulaSDKInstance.pay(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKPayCallback", JSON.stringify(PayResult));
  };
  GameGlobal.NebulaUnityCreateSurvey = async (args) => {
    const surveyResult = await nebulaSDKInstance.createSurvey(args);
    if (surveyResult.data?.survey) {
      gameGlobalState.surveyList.push(surveyResult.data.survey);
    }
    const callbackValue = {
      surveyId: surveyResult.data?.survey?.data?.id,
      surveyTitle: surveyResult.data?.survey?.data?.title
    };
    const callbackResult = { status: "success", code: SDKStatusCode.Success, msg: "创建问卷成功", data: callbackValue };
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKCreateSurveyCallback", JSON.stringify(callbackResult));
  };
  GameGlobal.NebulaUnityShowSurvey = async (args) => {
    const survey = gameGlobalState.surveyList.find((surveyItem) => surveyItem.data?.id === args.surveyId);
    try {
      if (!survey) throw new Error("survey is not found");
      await survey.show();
      const callback = (extraData) => {
        const callbackValue = {
          status: "success",
          code: SDKStatusCode.Success,
          msg: "打开问卷成功",
          data: { ...args, answerStatus: extraData?.status }
        };
        GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKShowSurveyCallback", JSON.stringify(callbackValue));
        survey.offClose(callback);
      };
      survey.onClose(callback);
    } catch (error) {
      const callbackValue = {
        status: "error",
        code: error?.errMsg === "navigateToMiniProgramWithoutTapCheck:fail cancel" ? SDKStatusCode.SurveyCancelError : SDKStatusCode.SurveyError,
        msg: "打开问卷失败",
        data: { ...args, answerStatus: "" }
      };
      GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKShowSurveyCallback", JSON.stringify(callbackValue));
    }
  };
  GameGlobal.NebulaUnityRequestSubscribeMessage = async (args) => {
    const subscribeResult = await nebulaSDKInstance.requestSubscribeMessage(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKSubscribeMessageCallback", JSON.stringify(subscribeResult));
  };
  GameGlobal.NebulaUnityShareAppMessage = async (args) => {
    const shareResult = await nebulaSDKInstance.shareAppMessage(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKShareAppMessageCallback", JSON.stringify(shareResult));
  };
  GameGlobal.NebulaUnityOnShareAppMessage = async (args) => {
    const shareResult = await nebulaSDKInstance.onShareAppMessage(args);
    GameGlobal.Module.SendMessage("NebulaSDKBridgeCallback", "NebulaSDKOnShareAppMessageCallback", JSON.stringify(shareResult));
  };
}

module.exports = nebulaSDKInstance;
